//
//  CustomCell.m
//  ImageTextCellSample
//
//  Created by Christos Sotiriou on 2/25/10.
//  Copyright 2010 Tei of Pireus. All rights reserved.
//

#import "CustomCell.h"


@implementation CustomCell

- (id) init
{
	self = [super init];
	if (self != nil) {
		NSLog(@"customcell init");
		//[self setEditable:NO];
		//[self setEnabled:NO];
		
	}
	return self;
}


- (id) copyWithZone:(NSZone *)zone
{
	CustomCell *cell = (CustomCell *)[super copyWithZone:zone];
	cell->delegate = nil;
	[cell setDataDelegate:delegate];
	return cell;
}

- (void)setDataDelegate:(NSObject *)adelegate
{
	[adelegate retain];
	[delegate autorelease];
	delegate =  adelegate;
}

- (void)setProp1KeyPath:(NSString *)path
{
	[prop1KeyPath autorelease];
	prop1KeyPath = [path retain];
}

- (void)setProp2KeyPath:(NSString *)path
{
	[prop2KeyPath autorelease];
	prop2KeyPath = [path retain];
}

- (NSObject *)dataDelegate
{
	if (delegate) {
		return delegate;
	}
	return self;
}


- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
	
	NSObject *data = [self objectValue];
	NSString *primaryText = [self prop1ForCell:self data:data];
	
	NSDictionary* primaryTextAttributes = [NSDictionary dictionaryWithObjectsAndKeys: [NSColor blackColor], NSForegroundColorAttributeName,[NSFont systemFontOfSize:13], NSFontAttributeName, nil];
	[primaryText drawAtPoint:NSMakePoint(cellFrame.origin.x+cellFrame.size.height+10, cellFrame.origin.y) withAttributes:primaryTextAttributes];
	
	NSString *secondaryText = [self prop2ForCell:self data:data];
	[secondaryText drawAtPoint:NSMakePoint(cellFrame.origin.x + 30, cellFrame.origin.y+ 30) withAttributes:primaryTextAttributes];
}

- (NSString *)prop1ForCell: (CustomCell *)cell data:(NSObject *)data
{
	return [data valueForKeyPath:prop1KeyPath];
}
- (NSString *)prop2ForCell: (CustomCell *)cell data:(NSObject *)data
{
	return [data valueForKeyPath:prop2KeyPath];
}

- (void) dealloc
{
	[prop1KeyPath release];
	[prop2KeyPath release];
	[self setDataDelegate:nil];
	[super dealloc];
}

@end
